// Copyright Spring project, Hugh Perkins 2006
// hughperkins@gmail.com http://manageddreams.com
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURVector3E. See the GNU General Public License for
//  more details.
//
// You should have received a copy of the GNU General Public License along
// with this program in the file licence.txt; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-
// 1307 USA
// You can find the licence also on the web at:
// http://www.opensource.org/licenses/gpl-license.php
//
// ======================================================================================
//

using System;
using System.IO;
using System.Collections;

namespace CSharpAI
{
    public enum MoveType{
            Ground_Move,
            Hover_Move,
            Ship_Move
    };
        
    public interface IMoveData
    {
        MoveType moveType{ get; }
        int size{ get; }
    
        double depth{ get; }
        double maxSlope{ get; }
        double slopeMod{ get; }
        double depthMod{ get; }
    
        int pathType{ get; }
        //CMoveMath* moveMath;
        double crushStrength{ get; }
        int moveFamily{ get; }				//0=tank,1=kbot,2=hover,3=ship        
    }
}
